package cz.muni.fi.pb162.ballpens;

/**
 * Tato trida slouzi pouze pro testovani spravnosti reseni, 
 * neni soucasti zadani.
 */

public class PenFactoryTest extends junit.framework.TestCase
{
    public void setUp()
    {
    }
    
    public void tearDown()
    {
    }
    
    public void testCartridge()
    {
        Cartridge c = new Cartridge("_barva_");
        assertEquals("getColor() vraci spatnou barvu (chyba v konstruktoru?)", "_barva_", c.getColor());
        assertEquals("Metoda toString() nevraci ocekavany retezec \"Napln: _barva_\"", "Napln: _barva_", c.toString());
    }
    
    public void testBallpen()
    {
        Ballpen p = new Ballpen();
        p.setLogo("_logo_");
        assertEquals("Metoda toString() nevraci ocekavany retezec \"Logo: _logo_, bez naplne\"", "Logo: _logo_, bez naplne", p.toString());
        Cartridge c = new Cartridge("_barva_");
        p.setCartridge(c);
        assertNotNull("Metoda setCartridge() nenastavuje napln", p.getCartridge());
        assertEquals("Metoda toString() nevraci ocekavany retezec \"Logo: _logo_, napln: _barva_\"", "Logo: _logo_, napln: _barva_", p.toString());
    }
    
    public void testFactory() 
    {
        PenFactory factory = new PenFactory();
        assertEquals("V nove vyrobne ma byt nula vyrobenych propisek (spatna inicializace citace?)", factory.producedBallpens(), 0);
        assertEquals("V nove vyrobne ma byt nula vyrobenych naplni (spatna inicializace citace?)", factory.producedCartridges(), 0);

        Ballpen p = factory.produceBallpen("ytrewq","");        
        assertNotNull("Metoda produceBallpen() nevraci novou propisku", p);
        assertEquals("Metoda produceBallpen() neinkrementuje citac", factory.producedBallpens(), 1);
        assertNotNull("Metoda produceBallpen() nevytvari novou napln v propisce", p.getCartridge());
        assertEquals("Metoda produceBallpen() neinkrementuje citac naplni", factory.producedCartridges(), 1);
        assertEquals("", "ytrewq", p.getCartridge().getColor());
        
        Cartridge n = factory.produceCartridge("qwerty");
        assertNotNull("Metoda produceCartridge() nevraci novou samostatnou napln", n);
        assertEquals("Metoda produceCartridge() neinkrementuje citac", factory.producedCartridges(), 2);
        assertEquals("Metoda produceCartridge() vraci napln se spatnou barvou", "qwerty", n.getColor());
    }
}
